          section   TEXT

          xdef      _fi2_actn
          xref      __usefi2
          xref      __freefi2
          xref      __c2qdos
          xref      __freestr

* Prototype: int fi2_actn(char * filename, short * actions, void ** array);

_fi2_actn MOVEM.L   D3/A2-A4,-(SP)                Save the context.
          MOVE.L    #'ACTN',D2                    Extension to be used.
          JSR       __usefi2                      Use it.
          BNE.S     FI2ACTN1                      If error, return now.
          MOVEA.L   20(SP),A1                     Address of "filename".
          JSR       __c2qdos                      Convert it into a QDOS string.
          BNE.S     FI2ACTN2                      If error, return now.
          MOVEQ     #-1,D2                        Mandatory.
          JSR       (A4)                          Call the extension.
          BNE.S     FI2ACTN3                      If error, return now.
          LEA       24(SP),A2                     Pointer on second parameter.
          MOVEA.L   (A2)+,A4                      Pointer on "actions" variable.
          MOVE.W    D2,(A4)                       Store the number of actions.
          MOVEA.L   (A2),A4                       Pointer on "array" variable.
          MOVE.L    A1,(A4)                       Store the array address in it.
FI2ACTN3  JSR       __freestr                     Free the filename heap space.
FI2ACTN2  JSR       __freefi2                     Free the extension thing.
FI2ACTN1  MOVEM.L   (SP)+,D3/A2-A4                Restore the context.
          RTS                                     Return to calling function.

          end
